SystemOrganization addCategory: #'SISS-Core'!

!AssignmentNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:44'!
sexpWith: aDictionary obj: obj

	| elems |
	elems _ WriteStream on: (Array new: 2).
	elems nextPut: (SExpElement keyword: #variable attributes: (SExpAttributes with: #value->variable key)).
	elems nextPut: (value sexpWith: aDictionary obj: obj).

	^ SExpElement keyword: #assign elements: elems contents.
! !

!TTCFontSet class methodsFor: '*siss-instance creation' stamp: 'yo 12/8/2007 00:24'!
familyName: aName size: aSize emphasized: emphasisCode

	^TTCFont familyName: aName pointSize: aSize emphasized: emphasisCode! !

!TTCFontSet methodsFor: '*siss-interface' stamp: 'tfel 8/5/2016 16:49'!
sissStoreString

	^ self fontArray first fontNameWithPointSize, ' ', self fontArray first emphasis asString! !

!ReturnNode methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 15:14'!
sexpWith: aDictionary

	| n |
	n _ SExpElement keyword: #return.
	n addElements: (Array with: (expr sexpWith: aDictionary)).
	^ n.

! !

!ReturnNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 12:56'!
sexpWith: aDictionary obj: obj

	| n |
	n _ SExpElement keyword: #return.
	n addElements: (Array with: (expr sexpWith: aDictionary obj: obj)).
	^ n.

! !

!Browser class methodsFor: '*siss-private' stamp: 'yo 3/24/2007 08:52'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| b dict |
	b _ self new.
	idref ifNotNil: [to at: idref put: b].
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	b setClass: (Smalltalk at: (dict at: #selectedClassName) asSymbol) selector: nil.
	b openEditString: nil.
	^ b.
! !

!Browser methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 19:15'!
sissExportSpecification

	^ #(('selectedClassName' #selectedClassName)
		('metaClassIndicated' #metaClassIndicated))
! !

!Boolean class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ (sexp attributeAt: #value) = 'true'.
! !

!Boolean methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!WeakMessageSend methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 10:47'!
sissInstVarNamed: varName put: childInst in: context

	(varName at: 1) isDigit ifTrue: [
		self basicAt: varName asInteger put: childInst.
	] ifFalse: [
		self sissBasicInstVarNamed: varName put: childInst in: context
	].
! !

!CharacterSet class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:05'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!VariableNode methodsFor: '*siss-interface' stamp: 'yo 3/24/2007 10:06'!
sexpWith: aDictionary obj: obj

	| newElem k |
	newElem _ SExpElement keyword: #variable.
	(key isKindOf: LookupKey) ifTrue: [
		k _ key value.
		k isPlayerLike ifTrue: [
			newElem attributeAt: #idref put: (aDictionary at: k) idref.
			newElem attributeAt: #type put: 'Player'.
		] ifFalse: [
			newElem attributeAt: #value put: key key.
		]
	] ifFalse: [
		newElem attributeAt: #value put: key.
		key = 'self' ifTrue: [
			newElem attributeAt: #type put: 'Player'.
		].
	].
	^ newElem.

! !

!SparseLargeTable class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 12:27'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!SparseLargeTable methodsFor: '*siss-private' stamp: 'yo 3/5/2007 12:36'!
sissContentsInto: sexp context: dictionary
	self sissInstVarsInto: sexp context: dictionary.
	self sissIndexFieldsInto: sexp context: dictionary.! !

!SparseLargeTable methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:47'!
sissInstVarNamed: varName put: childInst in: context

	(varName at: 1) isDigit ifTrue: [
		self basicAt: varName asInteger put: childInst
	] ifFalse: [
		self sissBasicInstVarNamed: varName put: childInst in: context
	].
! !

!KedamaTurtleMorph methodsFor: '*siss-interface' stamp: 'yo 4/6/2007 10:56'!
sissComeFullyUpOnReloadFrom: from to: to

	self player turtles compileAllAccessors.
	self player clonedSequentialStub compileAllAccessors.
	super sissComeFullyUpOnReloadFrom: from to: to.
! !

!BlockClosure class methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:10'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| ret |
	ret _ Compiler evaluate: (sexp attributeAt: #value) for: nil logged: false.
	idref ifNotNil: [to at: idref put: ret].
	^ ret.
! !

!BlockClosure methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:09'!
sissIsLiteral

	^ true.
! !

!BlockClosure methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:10'!
sissStoreString

	| node |
	node _ self decompile.
	^ (DialectStream dialect: #ST80 contents: [:strm | node printOn: strm indent: 0]) asString
! !

!DirectoryEntry class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 12:00'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!DirectoryEntry methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:45'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context
! !

!TTCFont class methodsFor: '*siss-instance creation' stamp: 'yo 12/7/2007 15:41'!
familyName: aName size: aSize emphasized: emphasisCode

	^ self familyName: aName pointSize: aSize emphasized: emphasisCode! !

!ByteArray class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:42'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst bytes |
	bytes _ (Base64MimeConverter mimeDecodeToBytes: (sexp attributeAt: #value) readStream) contents.
	inst _ self new: bytes size.
	inst replaceFrom: 1 to: bytes size with: bytes startingAt: 1.
	idref ifNotNil: [to at: idref put: inst].
	^ inst.
! !

IdentityDictionary subclass: #SISSDictionaryForReading
	instanceVariableNames: 'nullDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Core'!

!SISSDictionaryForReading methodsFor: 'as yet unclassified' stamp: 'yo 4/3/2007 10:49'!
addClass: aClass

	| d |
	self at: aClass ifAbsentPut: [
		d _ Dictionary new: aClass allInstVarNames size.
		aClass allInstVarNames doWithIndex: [:e :i | d at: e put: i].
		d.
	].
! !

!SISSDictionaryForReading methodsFor: 'as yet unclassified' stamp: 'yo 4/3/2007 10:26'!
initialize

	nullDict _ Dictionary new: 0.
! !

!SISSDictionaryForReading methodsFor: 'as yet unclassified' stamp: 'yo 5/2/2007 23:23'!
sissInstVarNamed: iVar put: val of: anObject

	| ind |
	(anObject isBehavior and: [anObject isUniClass]) ifTrue: [
		ind _ anObject officialClass class allInstVarNames indexOf: iVar.
	] ifFalse: [
		ind _ (self at: anObject class ifAbsent: [nullDict]) at: iVar ifAbsent: [0].
	].
	ind > 0 ifTrue: [
		anObject instVarAt: ind put: val.
	] ifFalse: [
		" ask the class how to handle it..."
	].
! !

IdentityDictionary subclass: #SISSDictionaryForScanning
	instanceVariableNames: 'boundaryObjects'
	classVariableNames: 'PublishInSexp ReduceFormDepth'
	poolDictionaries: ''
	category: 'SISS-Core'!

SISSDictionaryForScanning subclass: #SISSDictionaryForGuideBook
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Core'!

!SISSDictionaryForGuideBook methodsFor: 'all' stamp: 'yo 2/20/2008 00:25'!
sissScanObjectsFrom: book

	| ret n child object |

	object _ (book pages copyWith: book color).

	ret _ object sissElementInContext: self.

	ret ifNil: [^ self sissScanObjectsFrom: nil].

	ret isString ifTrue: [
		"if object is just a literal, make up an element and return it."
		n _ SExpElement keyword: object class name.
		n attributeAt: #value put: ret.
		^ n
	].

	book world player ifNotNil: [self forceAdd: book world player].

	"Final fix up for scriptors."
	self keys do: [:e |
		(e isMemberOf: ScriptEditorMorph) ifTrue: [
			e playerScripted ifNotNil: [
				child _ e sexpScriptWith: self.
				(self at: e) addElements: (Array with: child).
			].
		]
	].
	^ self contents
! !

SISSDictionaryForScanning subclass: #SISSDictionaryForMorphCopying
	instanceVariableNames: 'allSubmorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Core'!

!SISSDictionaryForMorphCopying methodsFor: 'as yet unclassified' stamp: 'yo 5/2/2007 23:30'!
at: anObject ifNew: aBlock

	| newName newElem |
	(anObject isMorph and: [(allSubmorphs includes: anObject) not]) ifTrue: [^ nil].
	self at: anObject ifPresent: [:n | ^ n].
	newName _ (tally + 1) printString.
	newElem _ SExpElement keyword: (self headKeywordFor: anObject) attributes: (SExpAttributes with: #idref->newName).
	self at: anObject put: newElem.
	aBlock value: newElem.
	^ newElem.
! !

!SISSDictionaryForMorphCopying methodsFor: 'as yet unclassified' stamp: 'yo 5/2/2007 22:56'!
initializeSubmorphs: aMorph

	allSubmorphs _ IdentitySet new.
	aMorph allMorphsAndBookPagesInto: allSubmorphs
! !

!SISSDictionaryForScanning class methodsFor: 'instance creation' stamp: 'tfel 8/5/2016 16:43'!
new

	^ self basicNew initialize; initialize: 5; yourself! !

!SISSDictionaryForScanning class methodsFor: 'preferences' stamp: 'tfel 8/5/2016 17:16'!
publishInSexp

	<preference: 'Publish Projects as SISS Expressions'
		category: 'other'
		description: 'If true, projects are saved in Sexp form using SISS rather than as image segments'
		type: #Boolean>
	^ PublishInSexp ifNil: [PublishInSexp := true]! !

!SISSDictionaryForScanning class methodsFor: 'preferences' stamp: 'tfel 8/5/2016 17:16'!
publishInSexp: aBoolean

	^ PublishInSexp := aBoolean! !

!SISSDictionaryForScanning class methodsFor: 'accessing' stamp: 'yo 9/10/2007 10:42'!
reduceFormDepth

	^ ReduceFormDepth == true.
! !

!SISSDictionaryForScanning class methodsFor: 'accessing' stamp: 'yo 9/10/2007 14:14'!
reduceFormDepth: aBoolean

	ReduceFormDepth _ aBoolean.
! !

!SISSDictionaryForScanning class methodsFor: 'test' stamp: 'yo 3/7/2007 16:50'!
test1
"
	self test1
"
	| a b c d e f orig new |
	a _ Array new: 3.
	b _ #a.
	c _ 3.
	d _ $a.
	e _ Set with: a with: b with: c with: d.
	f _ {a. b. c. d. e}.

	#(Bag Array WeakArray OrderedCollection UrlArgumentList Set WeakSet) do: [:cls |
	orig _ (Smalltalk at: cls) withAll: f.
	new _ orig sissScanObjects sissReadObjects.
	self assert: [orig = new].
	].! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 3/23/2007 22:39'!
at: anObject ifNew: aBlock

	| newName newElem |
	(boundaryObjects includes: anObject) ifTrue: [^ nil].
	self at: anObject ifPresent: [:n | ^ n].
	newName _ (tally + 1) printString.
	newElem _ SExpElement keyword: (self headKeywordFor: anObject) attributes: (SExpAttributes with: #idref->newName).
	self at: anObject put: newElem.
	aBlock value: newElem.
	^ newElem.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 3/19/2007 14:02'!
boundaryObjects

	^ boundaryObjects
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 3/23/2007 22:46'!
contents

	| inst |
	inst _ SExpElement keyword: #objects attributes: (SExpAttributes with: #root->'1') elements: self values.
	^ inst.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 11/8/2007 16:13'!
forceAdd: anObject

	| newName newElem |
	(boundaryObjects includes: anObject) ifTrue: [^ nil].
	self at: anObject ifPresent: [:n | ^ n].
	newName _ (tally + 1) printString.
	newElem _ SExpElement keyword: #SISSProxy
				attributes: (SExpAttributes with: #idref->newName with: #selector->anObject sissProxySelector asString).
	self at: anObject put: newElem.
	^ newElem.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 3/26/2007 14:28'!
headKeywordFor: anObject

	anObject isBehavior ifTrue: [
		anObject isUniClass ifTrue: [^ anObject officialClass name].
		^ #Behavior
	].
	anObject class isUniClass ifTrue: [^ anObject class officialClass name].
	^ anObject class name.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'tfel 8/5/2016 16:41'!
initialize

	super initialize.
	boundaryObjects _ IdentitySet new.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 2/19/2008 11:47'!
sissScanObjectsFrom: object

	| ret n child |

	ret _ object sissElementInContext: self.

	ret ifNil: [^ self sissScanObjectsFrom: nil].

	ret isString ifTrue: [
		"if object is just a literal, make up an element and return it."
		n _ SExpElement keyword: object class name.
		n attributeAt: #value put: ret.
		^ n
	].

	"Final fix up for scriptors."
	self keys do: [:e |
		(e isMemberOf: ScriptEditorMorph) ifTrue: [
			e playerScripted ifNotNil: [
				child _ e sexpScriptWith: self.
				(self at: e) addElements: (Array with: child).
			].
		]
	].
	^ self contents
! !

!Set methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context

	self sissWithCollectionEntries ifFalse: [
		^ self sissBasicInstVarNamed: varName put: childInst in: context
	] ifTrue: [
		self add: childInst
	].
! !

!Set methodsFor: '*siss-private' stamp: 'yo 3/5/2007 15:58'!
sissWithCollectionEntries

	^ true.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/23/2007 22:18'!
classFromClassName: aName

	^ Smalltalk at: aName asSymbol ifAbsent: [self error: ''. Object].
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/4/2007 01:43'!
findIdref: idref context: aDictionary 
	^ idref isNil
		ifTrue: [nil]
		ifFalse: [aDictionary at: idref ifAbsent: [nil]]! !

!Object methodsFor: '*siss-private' stamp: 'yo 2/27/2008 14:25'!
fromSexp: sexp from: from to: to
	| className classObj idref obj cls meta uniId |
	idref := self idrefFromSexp: sexp.
	(obj _ self findIdref: idref context: to) ifNotNil: [^ obj].

	meta _ sexp attributeAt: #metaclass ifAbsent: [''].
	uniId _ sexp attributeAt: #uniclass ifAbsent: [''].
	(uniId ~= '' and: [meta ~= 'true']) ifTrue: [
		cls _ self fromSexp: (from at: uniId asSymbol) from: from to: to.
		to addClass: cls.
		(obj _ self findIdref: idref context: to) ifNotNil: [^ obj].
		^ cls sissCreateInstanceFromSexp: sexp idref: idref from: from to: to.
	].
	sexp keyword == #slot ifTrue: [
		className _ sexp attributeAt: #class ifAbsent: [
			^ self fromSexp: (from at: idref) from: from to: to.
		].
	] ifFalse: [
		className _ sexp keyword.
	].
	classObj _ self classFromClassName: className.
	(uniId ~= '' and: [meta = 'true']) ifTrue: [
		classObj _ self uniclassUnder: classObj fromSexp: sexp from: from to: to.
		to addClass: classObj.
		^ classObj
	].
	to addClass: classObj.
	^ classObj sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/4/2007 01:42'!
idrefFromSexp: sexp

	sexp attributeAt: #idref ifPresent: [:idref | ^ idref asSymbol].
	^ nil.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 4/3/2007 11:06'!
sissBasicInstVarNamed: varName put: childInst in: context

	context sissInstVarNamed: varName put: childInst of: self.! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/3/2007 20:04'!
sissBitsInto: sexp context: dictionary

	self class isBytes ifTrue: [
		self sissBytesInto: sexp context: dictionary.
		^ self.
	] ifFalse: [
		self sissWordsInto: sexp context: dictionary.
		^ self.
	].
	self error: 'error'.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/23/2007 21:29'!
sissBytesInto: sexp context: dictionary

	| elementsString |
	
	elementsString _ (Base64MimeConverter mimeEncode: self readStream) contents.
	sexp attributeAt: #value put: elementsString.
	sexp attributeAt: #basicSize put: self size printString.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/9/2007 10:42'!
sissChildrenInto: newElem context: dictionary

	self class isBits ifTrue: [
		self sissBitsInto: newElem context: dictionary.
		^ self.
	].
		
	self sissWithCollectionEntries ifTrue: [
		self sissMixedFieldsInto: newElem context: dictionary.
		^ self.
	].
	self sissInstVarsInto: newElem context: dictionary.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/16/2007 00:25'!
sissComeFullyUpOnReloadFrom: from to: to

	"Override if you like"
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 19:16'!
sissContentsInto: newElem context: dictionary
	"Override if you like"
	| info |
	info _ self sissExportSpecification.
	info size > 0 ifTrue: [
		self sissSpecification: info into: newElem context: dictionary.
		^ self.
	].
	self sissChildrenInto: newElem context: dictionary! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:04'!
sissElementInContext: dictionary

	self sissIsLiteral ifTrue: [
		^ self sissStoreString
	].

	^ dictionary at: self ifNew: [:newElem |
		self sissWriteValue sissContentsInto: newElem context: dictionary
	].
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 19:15'!
sissExportSpecification
	"Override if you like.
	If the size of the returned array is larger than zero, only the information specified this array is written out.  The returned array is an array of pairs, and the first element of each pair specifies the information name and the second specifies the selector name to get the value."
	^ #().
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/5/2007 12:13'!
sissIgnoreInstVarNames
	"Override if you like"
	^ #().
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/3/2007 21:36'!
sissIndexFieldsInto: sexp context: dictionary

	self sissWithBasicAt ifTrue: [
		^ self sissIndexFieldsWithBasicAtInto: sexp context: dictionary
	] ifFalse: [
		^ self sissIndexFieldsWithDoInto: sexp context: dictionary
	].
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:53'!
sissIndexFieldsWithBasicAtInto: sexp context: dictionary

	| child result elem |
	result _ WriteStream on: (Array new: self basicSize).
	1 to: self basicSize do: [:ind |
		elem _ self basicAt: ind.
		child _ elem ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: ind printString).
		].
	].
	sexp attributeAt: #basicSize put: self basicSize printString.
	sexp addElements: result contents.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:52'!
sissIndexFieldsWithDoInto: sexp context: dictionary

	| ind child result |
	ind _ 0.
	result _ WriteStream on: (Array new: self size).
	self do: [:elem |
		ind := ind + 1.
		child _ elem ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: ind printString).
		].
	].
	sexp attributeAt: #size put: self size printString.
	sexp addElements: result contents.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 10:47'!
sissInitializeFrom: sexp from: from to: to
	"override if you like"
	| varName childInst |
	sexp elements do: [:elem |
		varName _ elem attributeAt: #name ifAbsent: [].
		childInst _ self fromSexp: elem from: from to: to.
		self sissInstVarNamed: varName put: childInst in: to
	].
! !

!Object methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:45'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:54'!
sissInstVarsInto: sexp context: dictionary

	| instVars ind child elem ignore result |
	instVars := self class allInstVarNames.
	ind := 0.
	ignore _ self sissIgnoreInstVarNames.
	result _ WriteStream on: (Array new: instVars size).
	instVars do: [:nm |
		ind := ind + 1.
		(ignore includes: nm) ifFalse: [
			elem _ self instVarAt: ind.
		] ifTrue: [
			elem _ nil
		].
		child _ elem ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: nm).
		].
	].
	sexp addElements: result contents.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ false.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:45'!
sissMakeSlotSexpFor: elem child: child name: name

	| attrs |
	attrs _ WriteStream on: (SExpAttributes new: 3).
	child isString ifTrue: [
		attrs nextPut: (#class->elem class asString).
		attrs nextPut: (#value->child).
	] ifFalse: [
		attrs nextPut: (#idref->child idref).
	].
	attrs nextPut: (#name->name).
	^ SExpElement keyword: #slot attributes: attrs contents.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/2/2007 17:39'!
sissMixedFieldsInto: sexp context: dictionary
	self sissInstVarsInto: sexp context: dictionary.
	self sissIndexFieldsInto: sexp context: dictionary.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 15:27'!
sissScanObjects

	| dict |
	dict _ SISSDictionaryForScanning new initialize.

	^ dict sissScanObjectsFrom: self.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 11/8/2007 15:26'!
sissScanObjectsWithDict: dict

	^ dict sissScanObjectsFrom: self.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:01'!
sissSlotsFromSexp: sexp from: from to: to

	| dict |
	dict _ IdentityDictionary new.
	sexp elements do: [:e |
		e keyword == #slot ifTrue: [
			dict at: (e attributeAt: #name) asSymbol put: (self fromSexp: e from: from to: to)
		]
	].
	^ dict.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:55'!
sissSpecification: pairs into: sexp context: dictionary

	| child elem result |
	result _ WriteStream on: (Array new: pairs size).
	pairs do: [:pair |
		child _ (elem _ self perform: pair second)
			ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: pair first).
		].
	].
	sexp addElements: result contents.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:28'!
sissStoreString

	^ self storeString.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/5/2007 15:20'!
sissWithBasicAt

	^ true.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/5/2007 15:57'!
sissWithCollectionEntries

	^ self class isVariable
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/23/2007 21:30'!
sissWordsInto: sexp context: dictionary

	| elementsString w |

	w _ WriteStream on: (ByteArray new: self basicSize*4+4).
	self writeOn: w.
	elementsString _ (Base64MimeConverter mimeEncode: w contents readStream) contents.
	sexp attributeAt: #value put: elementsString.
	sexp attributeAt: #basicSize put: self size printString.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/4/2007 03:41'!
sissWriteValue
	"Override if you wish"

	^self! !

!Object methodsFor: '*siss-private' stamp: 'yo 2/27/2008 15:03'!
uniclassUnder: officialClass fromSexp: sexp from: from to: to

	| idref obj className p slotsString exemplar dict pool poolString sup |
	idref := self idrefFromSexp: sexp.
	(obj _ self findIdref: idref context: to) ifNotNil: [^ obj].

	sexp attributeAt: #exemplar ifPresent: [:ex |
		exemplar _ self fromSexp: (from at: ex asSymbol) from: from to: to.
		(obj _ self findIdref: idref context: to) ifNotNil: [p _ obj] ifNil: [
			officialClass = KedamaSequenceExecutionStub ifTrue: [
				p _ exemplar class createSequencialStubSubclass.
			].
			officialClass = KedamaTurtleVectorPlayer2 ifTrue: [
				p _ exemplar class createTurtleSubclass2.
			].
		].
	].

	p ifNil: [
		sup _ sexp elements detect: [:e | e keyword = #slot and: [(e attributeAt: #name ifAbsent: ['']) = 'superclass']] ifNone: [nil].
		sup ifNotNil: [sup _ self fromSexp: (from at: sup idref asSymbol) from: from to: to].
		className _ (sup ifNil: [officialClass]) chooseUniqueClassName.
		slotsString _ sexp attributeAt: #slotsString ifAbsent: [''].
		poolString _ sexp attributeAt: #poolString ifAbsent: [''].
		p _ (sup ifNil: [officialClass ]) subclass: className instanceVariableNames: slotsString 
			classVariableNames: poolString poolDictionaries: '' category: officialClass categoryForUniclasses.
		"subclasses _ dict at: #subclasses ifAbsent: [#()].
		subclasses do: [:sub | p addSubclass: sub]."
		
	].
	idref ifNotNil: [to at: idref put: p].
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	pool _ dict at: #classPool ifAbsent: [#()].
	pool associationsDo: [:e | p classPool at: e key put: e value].

	to addClass: p.
	officialClass == Player ifTrue: [
		slotsString substrings do: [:inst |
			p compileAccessorsFor: inst
		].
	].

	(dict at: #methods ifAbsent: [#()]) do: [:pair | p compile: pair second classified: pair first].
	p sissInitializeFrom: sexp from: from to: to.

	^ p.
! !

Object subclass: #SISSProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Core'!

!SISSProxy class methodsFor: 'as yet unclassified' stamp: 'yo 11/8/2007 16:31'!
worldPlayer

	^ ActiveWorld assuredPlayer.
! !

!Metaclass class methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 15:01'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| dict |
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	^ (Smalltalk at: (dict at: #theNonMetaClassName) asSymbol) class.
! !

!Metaclass methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 14:57'!
sissExportSpecification

	^ #(('theNonMetaClassName' #theNonMetaClassName))
! !

!Array class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 12:00'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!SkipList methodsFor: '*siss-private' stamp: 'yo 3/5/2007 17:24'!
sissInstVarNamed: varName put: childInst
	self add: childInst.
	self size ~= varName asNumber ifTrue: [self error: 'wrong order'].
! !

!SkipList methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context
	self add: childInst.
	"self size ~= varName asNumber ifTrue: [self error: 'wrong order']."! !

!SkipList methodsFor: '*siss-private' stamp: 'yo 3/5/2007 17:23'!
sissWithCollectionEntries

	^ true.
! !

!ByteSymbol class methodsFor: '*siss-instance creation' stamp: 'yo 3/9/2007 11:04'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst |
	inst _ (sexp attributeAt: #value).
	inst _ self intern: inst.
	idref ifNotNil: [to at: idref put: inst].
	^ inst.
! !

!ByteSymbol methodsFor: '*siss-interface' stamp: 'yo 3/9/2007 11:19'!
sissStoreString

	^ self asString.
! !

!StrikeFont methodsFor: '*siss-private' stamp: 'yo 3/9/2007 13:45'!
sissStoreString

	^ self familyName, ' ', self height asString, ' ', self emphasis asString! !

!Form methodsFor: '*siss-interface' stamp: 'yo 9/10/2007 10:42'!
sissWriteValue

	SISSDictionaryForScanning reduceFormDepth ifTrue: [
		^ (self asFormOfDepth: 8) hibernate.
	].
	^ self hibernate.
! !

!SystemWindow class methodsFor: '*siss-private' stamp: 'yo 2/20/2008 14:59'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| model w contents dict |

	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	model _ dict at: #model ifAbsent: [].

	model ifNotNil: [
		(model isMemberOf: Workspace) ifTrue: [
			model embeddedInMorphicWindowLabeled: (dict at: #label).
			model sissSetContents: model contents.
		].
		w _ model dependents detect: [:e | e isMemberOf: SystemWindow] ifNone: [nil].
		w privateOwner: (dict at: #owner).
		w ifNotNil: [
			w bounds: (dict at: #bounds).
			idref ifNotNil: [to at: idref put: w].
			^ w.
		].
	] ifNil: [
		contents _ dict at: #contents ifAbsent: [].
		w _ contents embedInWindow.
		w privateOwner: (dict at: #owner).
		w bounds: (self fromSexp: (sexp elements detect: [:e | e keyword = #slot and: [(e attributeAt: #name) = #bounds]]) from: from to: to).
		idref ifNotNil: [to at: idref put: w].
		^ w.
	].
	w _  SystemWindow new.
	w privateOwner: (dict at: #owner).
	idref ifNotNil: [to at: idref put: w].
	^ w.
! !

!SystemWindow methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 20:47'!
contents

	^ self isCollapsed ifTrue: [nil] ifFalse: [submorphs second]
! !

!SystemWindow methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 21:39'!
model

	^ model
! !

!SystemWindow methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 21:39'!
modelOrContent

	^ model
! !

!SystemWindow methodsFor: '*siss-interface' stamp: 'yo 2/20/2008 14:34'!
sissExportSpecification

	^ #(('bounds' #bounds)
		('owner' #owner)
		('label' #label)
		('model' #model)
	)
! !

!SystemVersion class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 17:07'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ Current.

"
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	((Current date = (dict at: #date))
		and: [(Current version = (dict at: #version))
			and: [(Current hightestUpdate = (dict at: #hightestUpdate))]]) ifTrue: [
	].
"! !

!SystemVersion methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 17:08'!
sissContentsInto: newElem context: dictionary
! !

!Point class methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:24'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	"super sissCreateInstanceFromSexp: sexp idref: idref from: from to: to"
	| value ind x y |
	value _ (sexp attributeAt: #value).
	value first = $( ifTrue: [value := value allButFirst allButLast].
	ind := value indexOf: $@.
	x := (value copyFrom: 1 to: (ind - 1)) withBlanksTrimmed asNumber.
	y := (value copyFrom: ind + 1 to: value size) withBlanksTrimmed asNumber.
	^ x@y.
! !

!Point methodsFor: '*siss-private' stamp: 'yo 3/20/2007 21:54'!
sissIsLiteral

	^ true.
! !

!BlockContext class methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 14:06'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| ret |
	ret _ Compiler evaluate: (sexp attributeAt: #value) for: nil logged: false.
	idref ifNotNil: [to at: idref put: ret].
	^ ret.
! !

!BlockContext methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 14:07'!
sissIsLiteral

	^ true.
! !

!BlockContext methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 14:04'!
sissStoreString

	| node |
	node _ self decompile.
	^ (DialectStream dialect: #ST80 contents: [:strm | node printOn: strm indent: 0]) asString
! !

!Behavior class methodsFor: '*siss-interface' stamp: 'yo 3/21/2007 23:20'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| c |
	c _ Smalltalk at: (sexp attributeAt: #value) asSymbol.
	(sexp hasAttribute: #metaclass) ifTrue: [
		^ c class.
	].
	^ c.
! !

!Behavior methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:59'!
sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| inst |
	inst _ self sissNew: self withSexp: sexp.
	idref ifNotNil: [to at: idref put: inst].
	inst sissInitializeFrom: sexp from: from to: to.
	^ inst.
! !

!Behavior methodsFor: '*siss-instance creation' stamp: 'yo 2/27/2008 15:21'!
sissContentsInto: newElem context: dictionary

	self isUniClass ifTrue: [
		super sissContentsInto: newElem context: dictionary.
		newElem attributeAt: #uniclass put: newElem idref.
	].
	self class = Metaclass ifTrue: [
		newElem attributeAt: #metaclass put: 'true'.
		self theNonMetaclass isUniClass ifTrue: [
			newElem attributeAt: #uniclass put: newElem idref.
		].
	] ifFalse: [
		self isUniClass ifFalse: [
			newElem attributeAt: #value put: self name.]
	].
! !

!Behavior methodsFor: '*siss-instance creation' stamp: 'yo 3/21/2007 23:13'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	"override if you like"
	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Behavior methodsFor: '*siss-private' stamp: 'yo 3/4/2007 01:47'!
sissNew: aClass withSexp: sexp

	sexp attributeAt: #basicSize ifPresent: [:basicSize |
		^ aClass basicNew: (Integer readFromString: basicSize).
	].
	sexp attributeAt: #size ifPresent: [:size |
		^ aClass new: (Integer readFromString: size).
	].
	^ aClass basicNew.
! !

!ArrayedCollection class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst |
	inst _ self newFromStream: (Base64MimeConverter mimeDecodeToBytes: (sexp attributeAt: #value) readStream) reset.
	idref ifNotNil: [to at: idref put: inst].
	^ inst.
! !

!ArrayedCollection methodsFor: '*siss-private' stamp: 'yo 3/4/2007 03:53'!
sissInstVarNamed: varName put: childInst

	self sissWithBasicAt ifTrue: [
		self basicAt: varName asInteger put: childInst
	] ifFalse: [
		self at: varName asInteger put: childInst
	].
! !

!ArrayedCollection methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:45'!
sissInstVarNamed: varName put: childInst in: context

	self sissWithBasicAt ifTrue: [
		self basicAt: varName asInteger put: childInst
	] ifFalse: [
		self at: varName asInteger put: childInst
	].
! !

!ArrayedCollection methodsFor: '*siss-private' stamp: 'yo 3/3/2007 21:39'!
sissWithBasicAt

	^ true.
! !

!Float class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst str |
	
	str _ (Base64MimeConverter mimeDecodeToBytes: (sexp attributeAt: #value) readStream) reset.
	inst _ Float basicNew: 2.
	inst basicAt: 1 put: (str nextNumber: 4).
	inst basicAt: 2 put: (str nextNumber: 4).
	^ inst.
! !

!Float methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:27'!
sissStoreString

	| w |
	w _ WriteStream on: (ByteArray new: self size*4).
	self writeOn: w.
	^ (Base64MimeConverter mimeEncode: w contents readStream) contents.
! !

!Float methodsFor: '*siss-private' stamp: 'yo 3/4/2007 21:50'!
writeOn: aStream
	aStream nextWordsPutAll: self.! !

!MethodNode methodsFor: '*siss-interface' stamp: 'yo 9/11/2007 14:56'!
sexpWith: aDictionary obj: obj

	| elems n pSexp tmp tmps |

	elems _ WriteStream on: (Array new: arguments size + 1).
	n _ SExpElement keyword: #slot.
	n attributeAt: #name put: 'script'.
	n attributeAt: #scriptName put: (selectorOrFalse isSymbol ifTrue: [selectorOrFalse] ifFalse: [selectorOrFalse key]).
	n attributeAt: #language put: 'Squeak'.

	pSexp _ aDictionary at: encoder classEncoding ifAbsent: [].
	n attributeAt: #playerClass put: (pSexp ifNotNil: [pSexp idref] ifNil: ['0']).

	1 to: arguments size do: [:i |
		elems nextPut: ((SExpElement keyword: #parameter)
							attributeAt: #position put: i printString;
							attributeAt: #name put: (arguments at: i) key; yourself).
	].

	temporaries size > 0 ifTrue: [
		tmp _ SExpElement keyword: #temporary.
		tmps _ WriteStream on: Array new.
		temporaries do: [:e |
			tmps nextPut: (e sexpWith: aDictionary obj: obj).
		].
		tmp elements: tmps contents.
		elems nextPut: tmp.
	].

	elems nextPut: (block sexpWith: aDictionary obj: obj).

	n addElements: elems contents.
	^ n.
! !

!Rectangle class methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 11:54'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	"super sissCreateInstanceFromSexp: sexp idref: idref from: from to: to"
	| value ind indSpace origX origY cornerX cornerY |
	value := (sexp attributeAt: #value).
	value first = $( ifTrue: [value := value allButFirst allButLast].
	ind := value indexOf: $@.
	indSpace := value indexOf: Character space startingAt: ind+2.
	origX := (value copyFrom: 1 to: (ind - 1)) withBlanksTrimmed asNumber.
	origY := (value copyFrom: ind + 1 to: indSpace-1) withBlanksTrimmed asNumber.
	indSpace := value indexOf: Character space startingAt: indSpace+1.
	ind := value indexOf: $@ startingAt: indSpace+1.
	cornerX := (value copyFrom: indSpace+1 to: (ind - 1)) withBlanksTrimmed asNumber.
	cornerY := (value copyFrom: ind + 1 to: value size) withBlanksTrimmed asNumber.
	^ (origX@origY corner: cornerX@cornerY).
! !

!Rectangle methodsFor: '*siss-private' stamp: 'yo 3/20/2007 21:54'!
sissIsLiteral

	^ true.
! !

!UniclassScript methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:35'!
sissComeFullyUpOnReloadFrom: from to: to

	"currentScriptEditor
		sissComeFullyUpOnReloadFrom: from to: to;
		install;
		dismiss."! !

!UniclassScript methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 16:47'!
sissIgnoreInstVarNames

	^ #(formerScriptingTiles).
! !

!UniclassScript methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 08:54'!
sissWriteValue

	self isTextuallyCoded
		ifFalse: [self becomeTextuallyCoded.
				self revertToLastSavedTileVersionFor: self currentScriptEditor].! !

!SystemOrganizer class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 19:24'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ SystemOrganization.
! !

!SystemOrganizer methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 19:23'!
sissContentsInto: newElem context: dictionary
! !

!String methodsFor: '*siss-converting' stamp: 'yo 3/8/2007 18:25'!
sissEscape

	^ String streamContents: [:strm |
		self do: [:c |
			strm nextPutAll: c sissSequence
		]
	].
! !

!String methodsFor: '*siss-converting' stamp: 'yo 3/8/2007 21:54'!
sissUnescape

	| result c r v first aStream |
	aStream _ self readStream.
	result _ (String new: self size) writeStream.
	[(c _ aStream next) notNil] whileTrue: [
		c = $\ ifFalse: [
			result nextPut: c.
		] ifTrue: [
			c _ aStream next.
			c = $u ifTrue: [
				r _ 0.
				1 to: 4 do: [:i |
					c _ aStream next asUppercase.
					v _ '0123456789ABCDEF' indexOf: c startingAt: 1 ifAbsent: [self error: ''].
					r _ r * 16 + (v - 1).
				].
				(16rD800 <= r and: [r <= 16rDBFF]) ifTrue: [
					first _ r.
					r _ (aStream next: 6) sissUnescape.
					r _ (r at: 1) charCode.
					r _ (first - 16rD800) * 16r400 + (r - 16rDC00).
					result nextPut: (Character value: r).
				] ifFalse: [
					result nextPut: (Character value: r).
				].
			] ifFalse: [
				c = $x ifTrue: [
					r _ 0.
					1 to: 2 do: [:i |
						c _ aStream next asUppercase.
						v _ '0123456789ABCDEF' indexOf: c startingAt: 1 ifAbsent: [self error: ''].
						r _ r * 16 + (v - 1).
					].
					result nextPut: (Character value: r).
				] ifFalse: [
					result nextPut: c sissUnescape.
				].
			].
		].
	].
	^ result contents.
! !

!BlockNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:46'!
sexpWith: aDictionary obj: obj

	| elems n |
	elems _ WriteStream on: (Array new: arguments size + 1).
	n _ SExpElement keyword: #sequence.

	1 to: arguments size do: [:i |
		elems nextPut: (SExpElement
							keyword: #parameter
							attributes: (SExpAttributes
											with: #position->i printString
											with: #name->(arguments at: i) key)).
	].

	statements do: [:stmt |
		elems nextPut: (stmt sexpWith: aDictionary obj: obj).
	].

	n addElements: elems contents.
	^ n.
! !

!StandardSourceFileArray class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 15:25'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Preference class methodsFor: '*siss-private' stamp: 'yo 3/26/2008 16:23'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| aName |
	aName _ sexp attributeAt: #name ifAbsent: [].
	aName ifNotNil: [^ Preferences preferenceAt: aName asSymbol].
! !

!Preference methodsFor: '*siss-interface' stamp: 'yo 3/26/2008 16:15'!
sissContentsInto: newElem context: dictionary

	newElem attributeAt: #name put: name.
! !

!Collection methodsFor: '*siss-interface' stamp: 'yo 3/9/2007 10:43'!
sissContentsInto: newElem context: dictionary
	self class isBits ifTrue: [
		self sissBitsInto: newElem context: dictionary.
		^ self.
	].
	self sissWithCollectionEntries ifTrue: [
		self sissIndexFieldsInto: newElem context: dictionary.
		^ self.
	].
	self sissInstVarsInto: newElem context: dictionary.
! !

!Collection methodsFor: '*siss-private' stamp: 'yo 3/3/2007 21:37'!
sissWithBasicAt

	^ false.
! !

!RunArray class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:33'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!RunArray methodsFor: '*siss-interface' stamp: 'yo 2/27/2008 15:17'!
sissExportSpecification

	^ #(('runs' #runs)
		('values' #values)).
! !

!RunArray methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context
! !

!AbstractFont class methodsFor: '*siss-instance creation' stamp: 'tfel 8/7/2016 09:04'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| values familyName size emphasisCode |
	values := ((sexp attributeAt: #value) splitBy: ' ') asOrderedCollection.
	emphasisCode := values removeLast asInteger.
	size := values removeLast asInteger.
	familyName := values joinSeparatedBy: ' '.
	^self familyName: familyName size: size emphasized: emphasisCode.
! !

!AbstractFont methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!AbstractFont methodsFor: '*siss-interface' stamp: 'yo 3/5/2007 11:27'!
sissStoreString

	^ self fontNameWithPointSize, ' ', self emphasis asString! !

!TextStyle class methodsFor: '*siss-interface' stamp: 'tfel 8/5/2016 16:30'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| aName val ret |
	aName _ sexp attributeAt: #value ifAbsent: [].
	aName ifNil: [
		ret _ super sissCreateInstanceFromSexp: sexp idref: idref from: from to: to.
		ret instVarNamed: 'fontArray' put: (TextStyle named: ret fonts first familyName) fonts.
		^ ret.
	].
	val _ (TextStyle named: aName) ifNil: [TextStyle default].
	idref ifNotNil: [to at: idref put: val].
	^ val.
! !

!TextStyle methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 21:32'!
sissContentsInto: newElem context: dictionary
	| orig n |
	n _ self fonts first familyName.
	orig _ (TextStyle named: n).
	(self equals: orig) ifTrue: [
		"This equals: is a wierd one."
		newElem attributeAt: #value put: n.
	] ifFalse: [
		^ super sissContentsInto: newElem context: dictionary
	].
! !

!Player class methodsFor: '*siss-private' stamp: 'yo 4/6/2007 10:57'!
sissComeFullyUpOnReloadFrom: from to: to

	self slotInfo keys do: [:k |
		self compileInstVarAccessorsFor: k
	].
	super sissComeFullyUpOnReloadFrom: from to: to.
! !

!Player class methodsFor: '*siss-private' stamp: 'yo 3/30/2007 22:22'!
sissInstVarsInto: sexp context: dictionary

	super sissInstVarsInto: sexp context: dictionary.
	sexp attributeAt: #slotsString
		put: (String streamContents: [:strm |
				self instVarNames do: [:e | strm nextPutAll: e] separatedBy: [strm space]]).! !

!Player methodsFor: '*siss-interface' stamp: 'yo 2/27/2008 15:01'!
sissContentsInto: newElem context: dictionary
	| cls |
	super sissContentsInto: newElem context: dictionary.
	(self class isUniClass) ifTrue: [
		cls _ self class sissElementInContext: dictionary.
		cls ifNil: [^ self].
		newElem attributeAt: #uniclass put: cls idref.
	].
! !

!Player methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 16:31'!
sissProxySelector

	^ self costume isWorldMorph ifTrue: [^ #worldPlayer] ifFalse: [^ #yourself].
! !

!MessageNode methodsFor: '*siss-interface' stamp: 'yo 3/24/2007 08:57'!
condSexpWith: aDictionary for: sel obj: obj

	| newElem c y n |

	newElem _ SExpElement keyword: #condition.

	c _ receiver sexpWith: aDictionary obj: obj.
	(sel == #ifTrue: or: [sel == #ifTrue:ifFalse:]) ifTrue: [
		y _ (arguments at: 1) sexpWith: aDictionary obj: obj.
		sel == #ifTrue: ifTrue: [
			n _ SExpElement keyword: #sequence components: #().
		] ifFalse: [
			n _ (arguments at: 2) sexpWith: aDictionary obj: obj.
		].	
	].
	(sel == #ifFalse: or: [sel == #ifFalse:ifTrue:]) ifTrue: [
		n _ (arguments at: 1) sexpWith: aDictionary obj: obj.
		sel == #ifFalse: ifTrue: [
			y _ SExpElement keyword: #sequence components: #().
		] ifFalse: [
			y _ (arguments at: 2) sexpWith: aDictionary obj: obj.
		].	
	].

	newElem addElements: (Array with: c with: y with: n).
	^ newElem.
! !

!MessageNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 11:53'!
sexpWith: aDictionary obj: obj

	| sel elems n e |
	sel _ (selector isSymbol) ifTrue: [selector] ifFalse: [selector key].
	(#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:) includes: sel) ifTrue: [
		^ self condSexpWith: aDictionary for: sel obj: obj.
	].
	elems _ WriteStream on: (Array new: arguments size + 1).
	n _ SExpElement keyword: #send.

	e _ SExpElement keyword: #selector.
	e attributeAt: #selector put: sel.
	elems nextPut: e.
	elems nextPut: (receiver sexpWith: aDictionary obj: obj).
	arguments collect: [:a |
		elems nextPut: (a sexpWith: aDictionary obj: obj)
	].
	n addElements: elems contents.
	^ n.
! !

!Fraction class methodsFor: '*siss-instance creation' stamp: 'yo 5/2/2007 07:18'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| stream a b |
	stream _ (sexp attributeAt: #value) readStream.
	stream next = $( ifFalse: [^ 0].
	a _ Integer readFrom: stream.
	stream next = $/ ifFalse: [^ 0].
	b _ Number readFrom: stream.
	^ (a/b).
! !

!SoundBuffer methodsFor: '*siss-private' stamp: 'yo 3/5/2007 14:59'!
sissWriteValue
	"Override if you wish"

	| new |
	new _ self clone.
	new swapHalves.
	^ new.
! !

!ViewerFlapTab methodsFor: '*siss-interface' stamp: 'yo 3/31/2007 22:17'!
sissWriteValue

	self hibernate.
! !

!Color class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| vals rgb alpha inst |
	vals _ (sexp attributeAt: #value) substrings.
	rgb _ (vals at: 1) asNumber.
	alpha _ (vals at: 2) asNumber.
	alpha = 255 ifTrue: [
		inst _ Color basicNew.
		^ inst setRGB: rgb.
	].
	inst _ TranslucentColor basicNew.
	inst setRgb: rgb alpha: (alpha asFloat / 255.0).
	^ inst.
! !

!Color methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!Color methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:27'!
sissStoreString

	^ rgb printString, ' ', (self privateAlpha printString).
! !

!Symbol methodsFor: '*siss-interface' stamp: 'yo 3/9/2007 11:18'!
sissIsLiteral

	^ true.
! !

!CompoundTileMorph methodsFor: '*siss-interface' stamp: 'yo 2/19/2008 23:54'!
sissComeFullyUpOnReloadFrom: from to: to

	testPart borderWidth: 0; layoutInset: 1; color: Color transparent; height: 10; hResizing: #spaceFill.
	yesPart borderWidth: 0; layoutInset: 2; hResizing: #spaceFill; color: Color transparent.
	noPart borderWidth: 0; layoutInset: 2; hResizing: #spaceFill; color: Color transparent.! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/4/2007 16:33'!
bindingOf: varName

	self referencePoolOrNil ifNotNilDo: [:ref |
		^ ref associationAt: varName asSymbol ifAbsent: [nil].
	].
	^ nil.
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 11/5/2007 16:54'!
cleanUpReferences

	| all v w before now |
	all _ self presenter reallyAllExtantPlayersNoSort.
	self referencePoolIfPresentDo: [:ref |
		before _ SmallInteger maxVal.
		now _ ref size.
		[before > now] whileTrue: [
			ref keysDo: [:k |
				(v _ ref at: k) ifNil: [ref removeKey: k]
				ifNotNil: [
					v isPlayerLike ifTrue: [
						(all includes: v) ifFalse: [ref removeKey: k]
						ifTrue: [
							((w _ v costume topPasteUp) notNil
								and: [w ~~ self]) ifTrue: [
									w isWorldMorph ifTrue: [ref removeKey: k]]]]]].
			before _ now.
			now _ ref size.
		].
	].
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/5/2007 14:46'!
referencePoolIfPresentDo: aBlock

	^ self valueOfProperty: #References ifPresentDo: aBlock.
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/4/2007 16:32'!
referencePoolOrNil

	^ self valueOfProperty: #References ifAbsent: [nil].
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/5/2007 22:41'!
referenceWorldViaOwnwer

	self isWorldMorph ifTrue: [^ self].
	^ super referenceWorldViaOwnwer! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/6/2007 13:49'!
sissComeFullyUpOnReloadFrom: from to: to

	(self valueOfProperty: #soundAdditions) ifNotNilDo:
		[:additions | SampledSound assimilateSoundsFrom: additions].
	self removeProperty: #soundAdditions.
	super sissComeFullyUpOnReloadFrom: from to: to.
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 10:28'!
sissScanObjectsAsEtoysProject

	| dict ret |
	dict _ SISSDictionaryForScanning new initialize.
	self cleanUpReferences.
	self owner ifNotNil: [dict boundaryObjects add: self owner].
	dict boundaryObjects add: Utilities scrapsBook.
	Utilities scrapsBook pages do: [:p | dict boundaryObjects add: p].
	worldState ifNotNil: [self hands do: [:h | dict boundaryObjects add: h]].
	self project ifNotNil: [self setProperty: #projectVersion toValue: self project currentVersionNumber].
	ret _ dict sissScanObjectsFrom: self.
	self removeProperty: #projectVersion.

	^ ret.
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:43'!
sissWriteValue
	"Override if you wish"

	| new |
	self prepareToBeSaved.
	new _ self clone.
	new privateSubmorphs: (submorphs reject: [:e |
		e isDockingBar
			or: [(e isKindOf: SolidSugarSuppliesTab)
				or: [(e isKindOf: Viewer)
					or: [(e isKindOf: SugarNavTab)
						or: [((e isKindOf: SystemWindow) and: [(e model isKindOf: Workspace) not])
							or: [(e isMemberOf: FlapTab) and: [e isGlobalFlap]]]]]]]).
	new instVarNamed: 'presenter' put: nil.
	new instVarNamed: 'worldState' put: nil.
	new privateExtension: self extension copy.
	new extension removeOtherProperties.
	self extension otherProperties keysDo: [:sym |
		(#(commandKeySelectors lastKeystroke locked) includes: sym) ifFalse: [
			new setProperty: sym toValue: (self extension valueOfProperty: sym)
		].
	].

	^ new.
! !

!Interval class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 15:08'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Association class methodsFor: '*siss-interface' stamp: 'tfel 8/5/2016 16:21'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| n k className classObj v e |
	n _ self basicNew.
	idref ifNotNil: [to at: idref put: n].
	sexp attributeAt: #keyId ifPresent: [:id |
		k _ self fromSexp: (from at: id asSymbol) from: from to: to.
	] ifAbsent: [
		className _ sexp attributeAt: #keyClass.
		classObj _ self classFromClassName: className.
		e _ SExpElement keyword: className asSymbol attributes: (SExpAttributes with: (#value->(sexp attributeAt: #keyValue))).
		k _ classObj sissCreateInstanceFromSexp: e idref: nil from: from to: to.
	].
	sexp attributeAt: #valueId ifPresent: [:id |
		v _ self fromSexp: (from at: id asSymbol) from: from to: to.
	] ifAbsent: [
		className _ sexp attributeAt: #valueClass.
		classObj _ self classFromClassName: className.
		e _ SExpElement keyword: className asSymbol attributes: (SExpAttributes with: (#value->(sexp attributeAt: #valueValue))).
		v _ classObj sissCreateInstanceFromSexp: e idref: nil from: from to: to.
	].
	^ n key: k value: v.
! !

!Association methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:52'!
sissContentsInto: newElem context: dictionary

	| k v |
	k _ key sissElementInContext: dictionary.
	v _ value sissElementInContext: dictionary.
	key sissIsLiteral ifTrue: [
		newElem attributeAt: #keyClass put: key class name.
		newElem attributeAt: #keyValue put: k.
	] ifFalse: [
		newElem attributeAt: #keyId put: (k attributeAt: #idref).
	].
	value sissIsLiteral ifTrue: [
		newElem attributeAt: #valueClass put: value class name.
		newElem attributeAt: #valueValue put: v.
	] ifFalse: [
		newElem attributeAt: #valueId put: (v attributeAt: #idref).
	].
! !

!KedamaSequenceExecutionStub methodsFor: '*siss-interface' stamp: 'yo 2/27/2008 15:00'!
sissContentsInto: newElem context: dictionary

	| cls |
	self sissChildrenInto: newElem context: dictionary.
	(self class isUniClass) ifTrue: [
		cls _ self class sissElementInContext: dictionary.
		cls ifNil: [^ self].
		newElem attributeAt: #uniclass put: cls idref.
		cls attributeAt: #exemplar put: (newElem elements detect: [:e | (e attributeAt: #name) = 'exampler']) idref.
	].
! !

!ParseNode methodsFor: '*siss-interface' stamp: 'yo 4/13/2007 10:27'!
isEToyBinaryExp

	^ false.
! !

!ParseNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 09:58'!
sexpWith: aDictionary

! !

!OrderedCollection methodsFor: '*siss-private' stamp: 'yo 3/5/2007 16:52'!
sissInstVarNamed: varName put: childInst
	self addLast: childInst.
	self size ~= varName asNumber ifTrue: [self error: 'wrong order'].
! !

!OrderedCollection methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context
	self addLast: childInst.
	"self size ~= varName asNumber ifTrue: [self error: 'wrong order']."
! !

!OrderedCollection methodsFor: '*siss-private' stamp: 'yo 3/5/2007 16:47'!
sissWithCollectionEntries

	^ true.
! !

!WorldState class methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 21:08'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| dict ws |
	ws _ self new.
	idref ifNotNil: [to at: idref put: ws].
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	ws viewBox: (dict at: #viewBox).
	^ ws.
! !

!WorldState methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 15:50'!
sissExportSpecification
	^ #(('viewBox' #viewBox))
! !

!Number class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| str inst |
	str _ sexp attributeAt: #value.
	inst _ Number readFromString: str.
	^ inst.
! !

!Number methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!PredicatedArray class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 12:00'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!PredicatedArray methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context! !

!SystemNavigation class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 16:56'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self default.
! !

!SystemNavigation methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 16:54'!
sissContentsInto: newElem context: dictionary
! !

!WeakValueAssociation methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:47'!
sissInstVarNamed: varName put: childInst in: context

	(varName at: 1) isDigit ifTrue: [
		self basicAt: varName asInteger put: childInst
	] ifFalse: [
		self sissBasicInstVarNamed: varName put: childInst in: context
	].
! !

!ClassDescription methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:43'!
sissInstVarsInto: sexp context: dictionary

	| instVars ind ignore elem child result |	
	instVars := self class allInstVarNames.
	ind := Object class allInstVarNames size.
	ignore _ self sissIgnoreInstVarNames.
	instVars _ instVars copyFrom: ind + 1 to: instVars size.
	result _ WriteStream on: (Array new: instVars size).

	sexp attributeAt: #metaclass put: 'true'.

	instVars do: [:nm |
		ind := ind + 1.
		(ignore includes: nm) ifFalse: [
			elem _ self instVarAt: ind.
		] ifTrue: [
			elem _ nil
		].
		child _ elem ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: nm)
		].
	].
	sexp addElements: result contents.
! !

!Dictionary methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:45'!
sissIndexFieldsWithDoInto: sexp context: dictionary

	| ind child result |
	ind _ 0.
	result _ WriteStream on: (Array new: self size).
	self associationsDo: [:elem |
		ind := ind + 1.
		child _ elem sissElementInContext: dictionary.
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: ind printString).
		].
	].
	sexp attributeAt: #size put: self size printString.
	sexp addElements: result contents.
! !

!LiteralNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 14:45'!
sexpWith: aDictionary obj: obj

	| newElem |
	newElem _ SExpElement keyword: #literal.
	newElem attributeAt: #value put: key asString.
	newElem attributeAt: #type put: key class name.
	^ newElem.
! !

!Morph methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 15:26'!
sissScanObjectsForMorphCopy

	| dict |
	dict _ SISSDictionaryForMorphCopying new initialize.
	dict initializeSubmorphs: self.
	^ dict sissScanObjectsFrom: self.
! !

!Morph methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 15:29'!
sissScanObjectsWithoutOwner

	| dict |
	dict _ SISSDictionaryForScanning new initialize.
	self owner ifNotNil: [
		dict boundaryObjects add: self owner.
	].
	^ dict sissScanObjectsFrom: self.
! !

!Morph methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 21:36'!
sissWriteValue

	self prepareToBeSaved.
! !

!Morph methodsFor: '*siss-interface' stamp: 'yo 4/4/2007 16:37'!
uniqueNameForReferenceOrNil

	^ nil.
! !

!Character class methodsFor: '*siss-instance creation' stamp: 'tfel 8/7/2016 09:06'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| str v |
	str := sexp attributeAt: #value.
	(str first) = $$ ifTrue: [^ str second].
	(str startsWith: 'Character ') ifTrue: [^ Character perform: (str splitBy: ' ') last asSymbol].
	v := Integer readFrom: str readStream.
	^ self value: v.
! !

!Character methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!Character methodsFor: '*siss-private' stamp: 'tfel 8/7/2016 08:43'!
sissStoreString

	self asInteger < 256 ifTrue: [^ self printString].
	^ self asInteger printString.
! !

!Project class methodsFor: '*siss-interface' stamp: 'tfel 8/5/2016 17:16'!
publishInSexp

	^ SISSDictionaryForScanning publishInSexp
! !

!Project class methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 21:13'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| dict n p |

	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	n _ dict at: #name ifAbsent: [].
	p _ Project named: n.
	p ifNil: [p _ Project newMorphic renameTo: n].
	idref ifNotNil: [to at: idref put: p].
	^ p.
! !

!Project methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 21:03'!
sissExportSpecification

	^ #(('name' #name)
	)
! !

!Matrix class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:07'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Text class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:59'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Text methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:47'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context! !

!UndefinedObject class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:59'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ nil
! !

!UndefinedObject methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!SystemDictionary class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 16:53'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ Smalltalk.
! !

!SystemDictionary methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 16:52'!
sissContentsInto: newElem context: dictionary
! !

!FlapTab methodsFor: '*siss-interface' stamp: 'yo 3/28/2008 17:13'!
sissComeFullyUpOnReloadFrom: from to: to

	self isCurrentlyTextual ifTrue: [
		self changeTabText2: labelString
	].! !

!SmalltalkImage class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 17:14'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self current.
! !

!SmalltalkImage methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 17:13'!
sissContentsInto: newElem context: dictionary
! !

!ByteString class methodsFor: '*siss-instance creation' stamp: 'yo 3/9/2007 11:05'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst |
	inst _ (sexp attributeAt: #value).
	idref ifNotNil: [to at: idref put: inst].
	^ inst.
! !

!ByteString methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:55'!
sissBytesInto: sexp context: dictionary

	sexp attributeAt: #value put: self.
	sexp attributeAt: #basicSize put: self size printString.
! !
